//-fdefer-pop -fomit-frame-pointer -fcse-follow-jumps -fcse-skip-blocks -fexpensive-optimizations -fthread-jumps -fstrength-reduce -fpeephole -fforce-mem -ffunction-cse -finline-functions -finline -fkeep-static-consts -fcaller-saves -fpcc-struct-return -frerun-cse-after-loop -frerun-loop-opt -fschedule-insns2 -fsched-interblock -fsched-spec -fcommon -fverbose-asm -fgnu-linker -fregmove -falias-check -fargument-alias -fcompare-elim -fsign-extension-elim -fjump-back -fopt-reg-use -fall-mem-givs -freduce-index-givs -fpeep-spills -fsoftware-pipe -fcopy-prop -flift-stores -fruntime-lift-stores -fdo-offload -fcorrect-cse-mistakes -fopt-jumps-out -freplace-mem -freplace-stack-mem -finterleave-stack-non-stack -fschedule-stack-reg-insns -freg-reg-copy-opt -fpush-load-into-loop -fswap-for-agi -frisc -frisc-const -freplace-reload-regs -frisc-mem-dest -m80387 -mhard-float -mno-soft-float -mieee-fp -mfp-ret-in-387 -mschedule-prologue -mstack-align-double -mcpu=pentium -march=pentium

extern unsigned long H[256];

#define adripsx_id "Neo AdriPSX 00.00.00"

#define	INT2BCD(a)        ((a/10)*16+(a%10))
#define	BCD2INT(a)        ((a>>4)*10+(a&0xf))

typedef unsigned long long UINT64;
typedef signed long long INT64;
typedef unsigned long UINT32;
typedef signed long INT32;
typedef unsigned short UINT16;
typedef signed short INT16;
typedef unsigned char UINT8;
typedef signed char INT8;

#define delayCD2X 102
#define delayCD1X 150

#define DynaRec
#define DRBLOCKSIZE 4096
#define DRBLOCKS 4096

#define NoBigDebug

#define EmuCards
#define hleBIOS
#define hleRAM

#include <windows.h>
#include <prsht.h>
#include <commctrl.h>
#include <stdio.h>
#include <io.h>

#include "adripsx.h"

unsigned long wc=1;

unsigned long PSXused[0x80100];
unsigned char PSXcode[DRBLOCKSIZE*DRBLOCKS/6];

unsigned long TENER asm("_TENER");

static void incSector(void);
void INITcpu(void);
int psxload(char *name);
void ejecuta(void);
void ejecutaOLD(void);
void Load_Plugins();

unsigned long newPC, buff;

unsigned long SPUDEC = 0;
unsigned long XADEC = 0;
unsigned long CDADEC = 0;
unsigned long CDDEC = 0;
unsigned long NEWSPU = 0;
unsigned long NEWGPU = 0;
unsigned long MULTITASK = 0;
unsigned long CPUTYPE = 0;
unsigned long MDECSKIP = 0;
unsigned long noRTC = 1;
unsigned long LOADED = 1;
unsigned long NOHLE = 0;
unsigned long NOSTATIC = 0;

unsigned long CDISO=0;

unsigned long pad1m, pad2m;
unsigned long pad1c, pad2c;
unsigned char pad1d[5]={0x00,0x41,0x5a,0xff,0xff};
unsigned char pad2d[5]={0x00,0x41,0x5a,0xff,0xff};

unsigned long NextRTC0 asm("_NextRTC0") = 0xffffffff;
unsigned long NextRTC1 asm("_NextRTC1") = 0xffffffff;
unsigned long NextRTC2 asm("_NextRTC2") = 0xffffffff;
unsigned long TargetRTC0 asm("_TargetRTC0") = 0xffffffff;
unsigned long TargetRTC1 asm("_TargetRTC1") = 0xffffffff;
unsigned long TargetRTC2 asm("_TargetRTC2") = 0xffffffff;
void doRTC0(void);
void doRTC1(void);
void doRTC2(void);

unsigned long InstrCountHoriz, VerticalLine, VsyncCount;

unsigned long hardInterrupt=0;
unsigned long hardDMA=0xffffffff;

unsigned long delayCD=140;
unsigned long temporizer=0;
unsigned long tempohsync=0;
unsigned long rread=1, cdpos=0;
unsigned long cdOCUP=0;
unsigned char cdStat;
unsigned char cdParam[8];
unsigned char cdResult[8];
unsigned char cdParamC;
unsigned char cdParamP;
unsigned char cdResultC;
unsigned char cdResultP;
unsigned char cdResultReady;
unsigned char cdReaded;

unsigned char cdResultTN[6];
unsigned char cdResultTD[4];
unsigned char cdSetSector[4] = {0,0,0,0};
unsigned char cdSetSectorSeek[4] = {0,0,0,0};
unsigned long cdPlay;
unsigned long cdMode, cdFile=-1, cdChannel=0, cdTrack, cdMuted=0;
unsigned long cdReset = 0;
unsigned long cdV=0xffffffff;

unsigned long DoPAD=0x0;

unsigned long Runt=0;
unsigned long State=0;

#include "strucs.h"
AdriConfig Configuracion;
HWND *opio;
#include "pl.h"
#include "fasts.h"
#include "decs.h"
#include "spu.h"
#include "gpu.h"
#include "port.h"
#include "memcrd.h"
#include "r3000a.h"
#include "hle.h"
#include "cdcmd.h"
#include "hard.h"
#include "runtimer.h"

#include "iso.h"

void samain(void)
{
int register i;

 Load_Plugins();
 CDR_init();
 GPU_init();
 SPU_init();
 padd1.controllerType=1;
 padd2.controllerType=1;
 PAD_init(3);

 asm("movl $_PSXcode, pri");
 NextFree=pri+DRBLOCKSIZE;
 LastFree=pri+(DRBLOCKSIZE*((DRBLOCKS-24)/6));


 memset (trashMEMW, 0x00, 0x10000);
 memset (trashMEM, 0x00, 0x10000);
 for (i=0; i<=0xffff; i++)
 {
       if ((i>=0xbfc0) && (i<=0xbfc7)) { psxMEM[i]=(void *)psxR+((i&0x0007)<<16); psxMEMW[i]=(void *)trashMEMW; }
  else if ((i>=0x1fc0) && (i<=0x1fc7)) { psxMEM[i]=(void *)psxR+((i&0x0007)<<16); psxMEMW[i]=(void *)trashMEMW; }
  else if ((i>=0x9fc0) && (i<=0x9fc7)) { psxMEM[i]=(void *)psxR+((i&0x0007)<<16); psxMEMW[i]=(void *)trashMEMW; }
  else if ((i>=0x0000) && (i<=0x007f)) { psxMEMW[i]=(void *)psxM+((i&0x001f)<<16); psxMEM[i]=(void *)psxM+((i&0x001f)<<16); }
  else if ((i>=0x8000) && (i<=0x807f)) { psxMEMW[i]=(void *)psxM+((i&0x001f)<<16); psxMEM[i]=(void *)psxM+((i&0x001f)<<16); }
  else if ((i>=0xa000) && (i<=0xa07f)) { psxMEMW[i]=(void *)psxM+((i&0x001f)<<16); psxMEM[i]=(void *)psxM+((i&0x001f)<<16); }
  else if ((i>=0x1f00) && (i<=0x1f00)) { psxMEMW[i]=(void *)psxS+((i&0x0001)<<16); psxMEM[i]=(void *)psxS+((i&0x0001)<<16); }
  else if (i==0x1f80) { psxMEMW[i]=(void *)psxH; psxMEM[i]=(void *)psxH; }
  else { psxMEMW[i]=(void *)trashMEMW; psxMEM[i]=(void *)trashMEM; }
 }

 InitCard();
 mdec_init();
 resetPS();

 CDR_open();
 PAD_open(opio);

 Runt=1;

 WCD[0]=WcdREG0; WCD[1]=WcdREG1; WCD[2]=WcdREG2; WCD[3]=WcdREG3;
 RCD[0]=RcdREG0; RCD[1]=RcdREG1; RCD[2]=RcdREG2; RCD[3]=RcdREG3;

 if (State)
  {
   AskSTS();
   GPU_open(opio);
   SPU_open(opio);
   ReadSTS();
  }
 else
  {
   GPU_open(opio);
   SPU_open(opio);
  }

 setmeml(PSXused,TENER,524288);
 if (CPUTYPE) ejecutaOLD();
 else ejecuta();
}

HINSTANCE hInstance;

BOOL Open_File_Proc(HWND hwnd)
{
        char prevc[256];
        OPENFILENAME ofn;
	char szFileName[120];
	char szFileTitle[120];

       _getcwd(prevc, 255);

	memset(&szFileName,0,sizeof(szFileName));
	memset(&szFileTitle, 0, sizeof(szFileTitle));

        ofn.lStructSize			= sizeof(OPENFILENAME);
        ofn.hwndOwner			= hwnd;
        ofn.lpstrFilter			= "Psx Exe Format\0*.psx;*.exe;sc*.??;sl*.??\0";
	ofn.lpstrCustomFilter	        = NULL;
        ofn.nMaxCustFilter		= 0;
        ofn.nFilterIndex		= 1;
        ofn.lpstrFile			= szFileName;
        ofn.nMaxFile			= 120;
        ofn.lpstrInitialDir		= NULL;
        ofn.lpstrFileTitle		= szFileTitle;
        ofn.nMaxFileTitle		= 120;
        ofn.lpstrTitle			= "Open PSX Executable File\0";
        ofn.lpstrDefExt			= "TXT";
        ofn.Flags			= OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST;
	 
	if (GetOpenFileName ((LPOPENFILENAME)&ofn))
	{
        int i;
        for (i=0; i<120; i++) PSXloaded[i]=szFileName[i];
                chdir(prevc);
		return 1;
	}
	else
        {
                PSXloaded[0]='\n';
                chdir(prevc);
		return 0;
        }
}

BOOL Open_ISOFile_Proc(HWND hwnd)
{
        char prevc[256];
        OPENFILENAME ofn;
	char szFileName[120];
	char szFileTitle[120];

       _getcwd(prevc, 255);

	memset(&szFileName,0,sizeof(szFileName));
	memset(&szFileTitle, 0, sizeof(szFileTitle));

        ofn.lStructSize			= sizeof(OPENFILENAME);
        ofn.hwndOwner			= hwnd;
        ofn.lpstrFilter			= "Psx Cd-Rom Image File Format\0*.iso;*.bin;*.nrg\0";
	ofn.lpstrCustomFilter	        = NULL;
        ofn.nMaxCustFilter		= 0;
        ofn.nFilterIndex		= 1;
        ofn.lpstrFile			= szFileName;
        ofn.nMaxFile			= 120;
        ofn.lpstrInitialDir		= NULL;
        ofn.lpstrFileTitle		= szFileTitle;
        ofn.nMaxFileTitle		= 120;
        ofn.lpstrTitle			= "Open PSX CD-ROM Image File\0";
        ofn.lpstrDefExt			= "TXT";
        ofn.Flags			= OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST;
	 
	if (GetOpenFileName ((LPOPENFILENAME)&ofn))
	{
        int i;
        for (i=0; i<120; i++) PSXloaded[i]=szFileName[i];
                chdir(prevc);
		return 1;
	}
	else
        {
                PSXloaded[0]='\n';
                chdir(prevc);
		return 0;
        }
}

void Load_Plugins()
{
 LoadMCIplugin();
 LoadCDplugin();
 LoadGPUplugin();
 LoadSPUplugin();
 LoadPADplugin();

 if ((void*)GPU_writeDataMem == 0) NEWGPU=0;
 else NEWGPU=1;

 if ((void*)SPU_readDMA == 0) { SPUDEC=0; }
}

void getINI(FILE *arch, char *prev, char *output)
{
char tempi[256];
fseek (arch, 0, SEEK_SET);
sprintf (output, "\n");
while (feof(arch) == 0)
 {
  fscanf (arch, "%s", tempi);
  if (strcmp(tempi, prev) == 0) fscanf (arch, "%s", output);
 }
}

void readINI(void)
{
FILE *confi;
char temporal[256];
confi=fopen("AdriPSX.ini","rb");
if (confi == NULL) { MessageBox(0, "You must configure AdriPSX at least once.", "ERROR", MB_ICONSTOP); exit(0); }

getINI(confi, "GPU=", Configuracion.GPUplugin);
if (Configuracion.GPUplugin[0]=='\n') { MessageBox(0, "Can't find GPU Plugin name in AdriPSX.ini", "ERROR", MB_ICONSTOP); exit(0); }
getINI(confi, "SPU=", Configuracion.SPUplugin);
if (Configuracion.GPUplugin[0]=='\n') { MessageBox(0, "Can't find SPU Plugin name in AdriPSX.ini", "ERROR", MB_ICONSTOP); exit(0); }
getINI(confi, "CDR=", Configuracion.CDRplugin);
if (Configuracion.GPUplugin[0]=='\n') { MessageBox(0, "Can't find CDR Plugin name in AdriPSX.ini", "ERROR", MB_ICONSTOP); exit(0); }
getINI(confi, "PAD=", Configuracion.PADplugin);
if (Configuracion.PADplugin[0]=='\n') { MessageBox(0, "Can't find PAD Plugin name in AdriPSX.ini", "ERROR", MB_ICONSTOP); exit(0); }

getINI(confi, "ADPCM=", temporal);
if (temporal[0]=='1') SPUDEC=1; else SPUDEC=0;
getINI(confi, "CDXA=", temporal);
if (temporal[0]=='1') XADEC=1; else XADEC=0;
getINI(confi, "CDDA=", temporal);
if (temporal[0]=='1') CDADEC=1; else CDADEC=0;

CDDEC=0;
WCD[0]=WcdREG0; WCD[1]=WcdREG1; WCD[2]=WcdREG2; WCD[3]=WcdREG3;
RCD[0]=RcdREG0; RCD[1]=RcdREG1; RCD[2]=RcdREG2; RCD[3]=RcdREG3;

getINI(confi, "CDLETTER=", temporal);
dCD=temporal[0];

getINI(confi, "BIOS=", Configuracion.BIOSfile);
if (Configuracion.GPUplugin[0]=='\n') { MessageBox(0, "Can't find BIOS Image File name in AdriPSX.ini", "ERROR", MB_ICONSTOP); exit(0); }

getINI(confi, "SKIPMOVIES=", temporal);
if (temporal[0]=='1') MDECSKIP=1; else MDECSKIP=0;

getINI(confi, "CPUTYPE=", temporal);
if (temporal[0]=='1') CPUTYPE=1; else CPUTYPE=0;

getINI(confi, "RTCIRQ=", temporal);
if (temporal[0]=='1') noRTC=0; else noRTC=1;

getINI(confi, "MULTITASK=", temporal);
if (temporal[0]=='1') MULTITASK=1; else { MULTITASK=SPUDEC=XADEC=CDADEC=0; }

getINI(confi, "NOHLE=", temporal);
if (temporal[0]=='1') NOSTATIC=1; else NOSTATIC=0;

getINI(confi, "NOSTATIC=", temporal);
if (temporal[0]=='1') NOHLE=1; else NOHLE=0;

fclose(confi);
}


static void noRUN(HMENU *Hmenu)
{
 EnableMenuItem (Hmenu, IDM_BOOT ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_LOAD ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_LOADSTATE ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_START ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_ISO ,MF_GRAYED);
}

static void noCONFIG(HMENU *Hmenu)
{
 EnableMenuItem (Hmenu, IDM_BOOT ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_LOAD ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_LOADSTATE ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_START ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_GPU ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_SPU ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_CDR ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_CPU ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_PAD ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_BIOS ,MF_GRAYED);
 EnableMenuItem (Hmenu, IDM_ISO ,MF_GRAYED);
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    static HMENU hMenu;
    static HMENU hMenu_AdriPSX;

    switch (message) {
    case WM_CREATE:
        hMenu = GetMenu(hwnd);
        hMenu_AdriPSX = LoadMenu(hInstance, "MENU_ADRIPSX");
        return 0;

    case WM_DESTROY:
        if (rPC != 0xbfc00000) { SPU_shutdown(); SPU_close(); GPU_close(); }
        salDOS("Thank you for using AdriPSX.\n");
        return 0;

    case WM_COMMAND:
        switch (LOWORD(wParam))
        {
         case IDM_BOOT:
            readINI();
            if (loadCNF()) return(0);
            noCONFIG(hMenu);
            noRUN(hMenu);
            if (MULTITASK==0) SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);
            DestroyMenu(hMenu);
            samain();
            exit(0);
         break;

         case IDM_LOADSTATE:
            readINI();
            PSXloaded[0]='\n';
            noCONFIG(hMenu);
            noRUN(hMenu);
            if (MULTITASK==0) SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);
            DestroyMenu(hMenu);
            State=1;
            samain();
            exit(0);
         break;

         case IDM_LOAD:
            readINI();
            Open_File_Proc(hwnd);
            if (PSXloaded[0]=='\n') return(0);
            noCONFIG(hMenu);
            noRUN(hMenu);
            if (MULTITASK==0) SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);
            DestroyMenu(hMenu);
            samain();
            exit(0);
         break;

         case IDM_START:
            readINI();
            PSXloaded[0]='\n';
            noCONFIG(hMenu);
            noRUN(hMenu);
            if (MULTITASK==0) SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);
            DestroyMenu(hMenu);
            samain();
            exit(0);
         break;


         case IDM_ISO:
            Open_ISOFile_Proc(hwnd);
            if (PSXloaded[0]=='\n') return(0);
            loadISO();
            readINI();
            noCONFIG(hMenu);
            noRUN(hMenu);
            if (MULTITASK==0) SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST);
            DestroyMenu(hMenu);
            CDISO=1; CDADEC=0;
            samain();
            exit(0);
         break;

/*
         case IDM_ISOBUILD:
         {
          FILE *sfile;
          int i;
          char loc[4];
          int size;
          readINI();
          LoadCDplugin();
          CDR_init();
          ((UINT32*)loc)[0]=0x00100200;
          CD_Read(loc);

          size=RAWCDROM[103];
          size+=RAWCDROM[104]<<8;
          size+=RAWCDROM[105]<<16;
          size+=RAWCDROM[106]<<24;
          size=(size*8)/2352;

          if (size==0)
           {
            MessageBox(opio, "There was a problem while trying to read PSX CDROM.", adripsx_id, MB_OK | MB_ICONWARNING);
            return(0);
           }

          MessageBox(opio, "After pressing OK, CDROM imaging will begin. Then, please wait...", adripsx_id, MB_OK | MB_ICONWARNING);
          sfile=fopen("image.bin","wb");
          fwrite(psxM,1,2352*16,sfile);
          ((UINT32*)loc)[0]=0x00100200;
          for (i=0; i<size; i++)
           {
            CD_Read(loc);
            loc[2]++;
            if (loc[2]>74)
             {
              loc[2]=0; loc[1]++;
              if (loc[1]>59) { loc[1]=0; loc[0]++;}
             }
            fwrite(RAWCDROM,1,2352,sfile);
           }
          fclose(sfile);
          MessageBox(opio, "CDROM Image File succesfully created.", adripsx_id, MB_OK | MB_ICONWARNING);

         }
         exit(0);
         break;

         case IDM_ISOINFO:
         {
          char loc[4];
          int size;
          char info[256];
          readINI();
          LoadCDplugin();
          CDR_init();
          ((UINT32*)loc)[0]=0x00100200;
          CD_Read(loc);

          size=RAWCDROM[103];
          size+=RAWCDROM[104]<<8;
          size+=RAWCDROM[105]<<16;
          size+=RAWCDROM[106]<<24;
          size=(size*8)/2352;

          if ((size==0) || (loadCNF()==1) )
           {
            MessageBox(opio, "There was a problem while trying to read PSX CDROM.", adripsx_id, MB_OK | MB_ICONWARNING);
            return(0);
           }

          sprintf (info, "Product code: %s\n\nCD-ROM size: %09d bytes\n\nCD-ROM DRIVE: %c\n\n\n",PSXloaded+2,size*2352,dCD);

          MessageBox(opio, info, "CDROM INFO", MB_OK);
         }

         break;
*/

         case IDM_QUIT:
           if (MessageBox(opio, "Are you sure you want to quit?", "AdriPSX Emulator", MB_YESNO | MB_ICONQUESTION) == IDYES) salDOS("\n");
         break;

         case IDM_GPU:
            if (LOADED) { LoadGUIplugin(); MessageBox(0, "You should restart AdriPSX after configuring all features.", "Attention", MB_ICONSTOP); }
            LOADED=0;
            GetConfig();
            GPUset(0);
            GetConfig(); noRUN(hMenu);
         break;

         case IDM_SPU:
            if (LOADED) { LoadGUIplugin(); MessageBox(0, "You should restart AdriPSX after configuring all features.", "Attention", MB_ICONSTOP); }
            LOADED=0;
            GetConfig();
            SPUset(0);
            GetConfig(); noRUN(hMenu);
         break;

         case IDM_CDR:
            if (LOADED) { LoadGUIplugin(); MessageBox(0, "You should restart AdriPSX after configuring all features.", "Attention", MB_ICONSTOP); }
            LOADED=0;
            GetConfig();
            CDRset(0);
            GetConfig(); noRUN(hMenu);
         break;

         case IDM_PAD:
            if (LOADED) { LoadGUIplugin(); MessageBox(0, "You should restart AdriPSX after configuring all features.", "Attention", MB_ICONSTOP); }
            LOADED=0;
            GetConfig();
            PADset(0);
            GetConfig(); noRUN(hMenu);
         break;

         case IDM_ABOUT:
           MessageBox(opio, "\nAdriPSX - Sony Playstation Emulator\n\n\n Coded by:\n\n     Roor Makurosu\n\n     adripsx@psxemu.com\n\n", adripsx_id, MB_OK | MB_ICONHAND);
         break;


         case IDM_BIOS:
           MessageBox(opio, "Only can use SCPH1001.BIN on this development Beta.", adripsx_id, MB_OK | MB_ICONWARNING);
           break;

         case IDM_CPU:
            if (LOADED) { LoadGUIplugin(); MessageBox(0, "You should restart AdriPSX after configuring all features.", "Attention", MB_ICONSTOP); }
            LOADED=0;
            GetConfig();
            CPUset(0);
            GetConfig(); noRUN(hMenu);
         break;

        }
    }
    return DefWindowProc(hwnd, message, wParam, lParam);
}

int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInstance, LPSTR lpszCmdParam, int nCmdShow)
{
    HWND hwnd;
    MSG msg;
    WNDCLASS wndclass;

    hInstance = hInst;
     if (!hPrevInstance) {
        wndclass.style = 0;
        wndclass.lpfnWndProc = WndProc;
        wndclass.cbClsExtra = 0;
        wndclass.cbWndExtra = 0;
        wndclass.hInstance = hInstance;
        wndclass.hIcon = LoadIcon(hInstance, "AdriPSX");
        wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
        wndclass.hbrBackground = GetStockObject(BLACK_BRUSH);
        wndclass.lpszMenuName = "AdriPSX";
        wndclass.lpszClassName = "AdriPSX";
        RegisterClass(&wndclass);
    }

    hwnd = CreateWindow("AdriPSX", adripsx_id,
                        (WS_OVERLAPPED | WS_BORDER | WS_CAPTION | WS_VISIBLE),
                        50, 10, 400, 300,
                        NULL, NULL, hInstance, NULL);

    opio=hwnd;

    ShowWindow(hwnd, nCmdShow);
    UpdateWindow(hwnd);

 asm("movl $_compile2, _TENER");

 if (_strnicmp(lpszCmdParam, "/BOOT",5) == 0)
  {
   WndProc(opio, WM_COMMAND, IDM_BOOT, 0);
   exit(0);
  }

 while (GetMessage(&msg, NULL, 0, 0))
  {
   TranslateMessage(&msg);
   DispatchMessage(&msg);
  }

 return msg.wParam;
}
