GPUFreeze_t GPUsavestate;
savestate_t savestate;

extern struct {
	unsigned long command;
	unsigned long status;
	unsigned short *rl;
	int rlsize;
} mdec;
extern int iq_y[64];
extern int iq_uv[64];

char lastSTS[256];
char fileSTS[256];

int AskSTS(void)
{
        char prevc[256];
        OPENFILENAME ofn;
	char szFileName[120];
	char szFileTitle[120];

       _getcwd(prevc, 255);

	memset(&szFileName,0,sizeof(szFileName));
	memset(&szFileTitle, 0, sizeof(szFileTitle));

        sprintf (szFileName,"%s", lastSTS);

        ofn.lStructSize			= sizeof(OPENFILENAME);
        ofn.hwndOwner			= opio;
        ofn.lpstrFilter			= "AdriPSX SavesState\0*.sts\0";
	ofn.lpstrCustomFilter	        = NULL;
        ofn.nMaxCustFilter		= 0;
        ofn.nFilterIndex		= 1;
        ofn.lpstrFile			= szFileName;
        ofn.nMaxFile			= 120;
        ofn.lpstrInitialDir		= NULL;
        ofn.lpstrFileTitle		= szFileTitle;
        ofn.nMaxFileTitle		= 120;
        ofn.lpstrTitle			= "Load AdriPSX SavesState File\0";
        ofn.lpstrDefExt			= "STS";
        ofn.Flags			= OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST;
	 
	if (GetOpenFileName ((LPOPENFILENAME)&ofn))
	{
         int i;
         for (i=0; i<120; i++) fileSTS[i]=szFileName[i];
         chdir(prevc);
         return 1;
	}
	else {  chdir(prevc); return 0; }

}


void ReadSTS(void)
 {
    FILE *state;

    sprintf (lastSTS,"%s",fileSTS);

    state=fopen(fileSTS,"rb");
    if (state==NULL)
     {
      MessageBox(opio, "There was an error while trying to read the specified file.", "Attention!!!", MB_OK);
      return;
     }

    fread(&GPUsavestate, 1049608, 1, state);
    GPUsavestate.ulFreezeVersion=1;
    GPU__freeze(0, &GPUsavestate);

    fread(&GPUsavestate, 574288, 1, state);
    GPUsavestate.ulFreezeVersion=1;
    SPU__freeze(0, &GPUsavestate);

    fread(&mdec, 16, 1, state);
    fread(iq_y, 64*4, 1, state);
    fread(iq_uv, 64*4, 1, state);

    fread(&cd, 84, 1, state);
    fread((char*)psxM, 2*1024*1034, 1, state);
    fread((char*)psxH, 64*1034, 1, state);
    fread((char*)psxR, 512*1034, 1, state);
    fread((void*)reg, 4*32, 1, state);
    fread((void*)regCOP0, 4*32, 1, state);
    fread(&regg, 4*2*32, 1, state);

    fread(&savestate, 4*70, 1, state);
    fread((void*)H, 4*256, 1, state);

    rPC=savestate.rPC;
    regLO=savestate.regLO;
    regHI=savestate.regHI;
    NextRTC0=savestate.NextRTC0;
    NextRTC1=savestate.NextRTC1;
    NextRTC2=savestate.NextRTC2;
    TargetRTC0=savestate.TargetRTC0;
    TargetRTC1=savestate.TargetRTC1;
    TargetRTC2=savestate.TargetRTC2;
    InstrCountHoriz=savestate.InstrCountHoriz;
    VerticalLine=savestate.VerticalLine;
    VsyncCount=savestate.VsyncCount;
    hardInterrupt=savestate.hardInterrupt;
    delayCD=savestate.delayCD;
    temporizer=savestate.temporizer;
    rread=savestate.rread;
    cdpos=savestate.cdpos;
    cdOCUP=savestate.cdOCUP;
    cdStat=savestate.cdStat;
    cdParam[0]=savestate.cdParam[0];
    cdParam[1]=savestate.cdParam[1];
    cdParam[2]=savestate.cdParam[2];
    cdParam[3]=savestate.cdParam[3];
    cdParam[4]=savestate.cdParam[4];
    cdParam[5]=savestate.cdParam[5];
    cdParam[6]=savestate.cdParam[6];
    cdParam[7]=savestate.cdParam[7];
    cdResult[0]=savestate.cdResult[0];
    cdResult[1]=savestate.cdResult[1];
    cdResult[2]=savestate.cdResult[2];
    cdResult[3]=savestate.cdResult[3];
    cdResult[4]=savestate.cdResult[4];
    cdResult[5]=savestate.cdResult[5];
    cdResult[6]=savestate.cdResult[6];
    cdResult[7]=savestate.cdResult[7];
    cdParamC=savestate.cdParamC;
    cdParamP=savestate.cdParamP;
    cdResultReady=savestate.cdResultReady;
    cdReaded=savestate.cdReaded;
    cdResultTN[0]=savestate.cdResultTN[0];
    cdResultTN[1]=savestate.cdResultTN[1];
    cdResultTN[2]=savestate.cdResultTN[2];
    cdResultTN[3]=savestate.cdResultTN[3];
    cdResultTN[4]=savestate.cdResultTN[4];
    cdResultTN[5]=savestate.cdResultTN[5];
    cdResultTD[0]=savestate.cdResultTD[0];
    cdResultTD[1]=savestate.cdResultTD[1];
    cdResultTD[2]=savestate.cdResultTD[2];
    cdResultTD[3]=savestate.cdResultTD[3];
    cdSetSector[0]=savestate.cdSetSector[0];
    cdSetSector[1]=savestate.cdSetSector[1];
    cdSetSector[2]=savestate.cdSetSector[2];
    cdSetSector[3]=savestate.cdSetSector[3];
    cdSetSectorSeek[0]=savestate.cdSetSectorSeek[0];
    cdSetSectorSeek[1]=savestate.cdSetSectorSeek[1];
    cdSetSectorSeek[2]=savestate.cdSetSectorSeek[2];
    cdSetSectorSeek[3]=savestate.cdSetSectorSeek[3];
    cdPlay=savestate.cdPlay;
    cdMode=savestate.cdMode;
    cdFile=savestate.cdFile;
    cdChannel=savestate.cdChannel;
    cdTrack=savestate.cdTrack;
    cdReset=savestate.cdReset;
    cdV=savestate.cdV;
    DoPAD=savestate.DoPAD;

    fclose(state);

    setmeml(PSXused,TENER,524288);
    if (CPUTYPE) ejecutaOLD();
    else ejecuta();
 }

void WriteSTS(void)
 {
    FILE *state;
    char fileSTS[256];

        char prevc[256];
        OPENFILENAME ofn;
	char szFileName[120];
	char szFileTitle[120];

        SPU__shutdown(); SPU__close(); GPU__close();

       _getcwd(prevc, 255);

	memset(&szFileName,0,sizeof(szFileName));
	memset(&szFileTitle, 0, sizeof(szFileTitle));

        sprintf (szFileName,"%s", lastSTS);

        ofn.lStructSize			= sizeof(OPENFILENAME);
        ofn.hwndOwner			= opio;
        ofn.lpstrFilter			= "AdriPSX SavesState\0*.sts\0";
	ofn.lpstrCustomFilter	        = NULL;
        ofn.nMaxCustFilter		= 0;
        ofn.nFilterIndex		= 1;
        ofn.lpstrFile			= szFileName;
        ofn.nMaxFile			= 120;
        ofn.lpstrInitialDir		= NULL;
        ofn.lpstrFileTitle		= szFileTitle;
        ofn.nMaxFileTitle		= 120;
        ofn.lpstrTitle			= "Save AdriPSX SavesState File\0";
        ofn.lpstrDefExt			= "STS";
        ofn.Flags			= OFN_HIDEREADONLY | OFN_NOCHANGEDIR | OFN_PATHMUSTEXIST;
	 
	if (GetSaveFileName ((LPOPENFILENAME)&ofn))
	{
         int i;
         for (i=0; i<120; i++) fileSTS[i]=szFileName[i];
         chdir(prevc);
	}
	else { SPU__init(); GPU__open(opio); SPU__open(opio); chdir(prevc); return; }

    SPU__init(); GPU__open(opio); SPU__open(opio);

    sprintf (lastSTS,"%s",fileSTS);

    state=fopen(fileSTS,"wb");
    if (state==NULL)
     {
      MessageBox(opio, "There was an error while trying to save this file.", "Attention!!!", MB_OK);
      return;
     }

    GPUsavestate.ulFreezeVersion=1;
    GPU__freeze(1, &GPUsavestate);
    fwrite(&GPUsavestate, 1049608, 1, state);

    GPUsavestate.ulFreezeVersion=1;
    SPU__freeze(1, &GPUsavestate);
    fwrite(&GPUsavestate, 574288, 1, state);

    fwrite(&mdec, 16, 1, state);
    fwrite(iq_y, 64*4, 1, state);
    fwrite(iq_uv, 64*4, 1, state);

    fwrite(&cd, 84, 1, state);
    fwrite((char*)psxM, 2*1024*1034, 1, state);
    fwrite((char*)psxH, 64*1034, 1, state);
    fwrite((char*)psxR, 512*1034, 1, state);
    fwrite((void*)reg, 4*32, 1, state);
    fwrite((void*)regCOP0, 4*32, 1, state);
    fwrite(&regg, 4*2*32, 1, state);

    savestate.rPC=rPC;
    savestate.regLO=regLO;
    savestate.regHI=regHI;
    savestate.NextRTC0=NextRTC0;
    savestate.NextRTC1=NextRTC1;
    savestate.NextRTC2=NextRTC2;
    savestate.TargetRTC0=TargetRTC0;
    savestate.TargetRTC1=TargetRTC1;
    savestate.TargetRTC2=TargetRTC2;
    savestate.InstrCountHoriz=InstrCountHoriz;
    savestate.VerticalLine=VerticalLine;
    savestate.VsyncCount=VsyncCount;
    savestate.hardInterrupt=hardInterrupt;
    savestate.delayCD=delayCD;
    savestate.temporizer=temporizer;
    savestate.rread=rread;
    savestate.cdpos=cdpos;
    savestate.cdOCUP=cdOCUP;
    savestate.cdStat=cdStat;
    savestate.cdParam[0]=cdParam[0];
    savestate.cdParam[1]=cdParam[1];
    savestate.cdParam[2]=cdParam[2];
    savestate.cdParam[3]=cdParam[3];
    savestate.cdParam[4]=cdParam[4];
    savestate.cdParam[5]=cdParam[5];
    savestate.cdParam[6]=cdParam[6];
    savestate.cdParam[7]=cdParam[7];
    savestate.cdResult[0]=cdResult[0];
    savestate.cdResult[1]=cdResult[1];
    savestate.cdResult[2]=cdResult[2];
    savestate.cdResult[3]=cdResult[3];
    savestate.cdResult[4]=cdResult[4];
    savestate.cdResult[5]=cdResult[5];
    savestate.cdResult[6]=cdResult[6];
    savestate.cdResult[7]=cdResult[7];
    savestate.cdParamC=cdParamC;
    savestate.cdParamP=cdParamP;
    savestate.cdResultReady=cdResultReady;
    savestate.cdReaded=cdReaded;
    savestate.cdResultTN[0]=cdResultTN[0];
    savestate.cdResultTN[1]=cdResultTN[1];
    savestate.cdResultTN[2]=cdResultTN[2];
    savestate.cdResultTN[3]=cdResultTN[3];
    savestate.cdResultTN[4]=cdResultTN[4];
    savestate.cdResultTN[5]=cdResultTN[5];
    savestate.cdResultTD[0]=cdResultTD[0];
    savestate.cdResultTD[1]=cdResultTD[1];
    savestate.cdResultTD[2]=cdResultTD[2];
    savestate.cdResultTD[3]=cdResultTD[3];
    savestate.cdSetSector[0]=cdSetSector[0];
    savestate.cdSetSector[1]=cdSetSector[1];
    savestate.cdSetSector[2]=cdSetSector[2];
    savestate.cdSetSector[3]=cdSetSector[3];
    savestate.cdSetSectorSeek[0]=cdSetSectorSeek[0];
    savestate.cdSetSectorSeek[1]=cdSetSectorSeek[1];
    savestate.cdSetSectorSeek[2]=cdSetSectorSeek[2];
    savestate.cdSetSectorSeek[3]=cdSetSectorSeek[3];
    savestate.cdPlay=cdPlay;
    savestate.cdMode=cdMode;
    savestate.cdFile=cdFile;
    savestate.cdChannel=cdChannel;
    savestate.cdTrack=cdTrack;
    savestate.cdReset=cdReset;
    savestate.cdV=cdV;
    savestate.DoPAD=DoPAD;

    fwrite(&savestate, 4*70, 1, state);
    fwrite((void*)H, 4*256, 1, state);

    fclose(state);
   }

static void clearOT(int adres, int size)
{
register unsigned long OTCSTART, OTCEND;

      if (adres & 0x5f800000)
        {
         salDOS("EMULATION ERROR: OT TO BE CLEAREAD COULDN'T BE LOCATED IN MAIN RAM.");
        }
      OTCEND = (adres & 0x001fffff)>>2;
      OTCSTART=(OTCEND-size)+1;

      if (OTCSTART>0x7ffff) salDOS("EMULATION ERROR: BAD OT.");

      asm("
           shll $2, %%ecx
           shll $2, %%eax
           subl $4, %%ecx
           .align 4,0x90
           OTC:
           movl %%ecx, 4(%%ebx, %%ecx,1)
           addl $4, %%ecx
           cmpl %%eax, %%ecx
           jne OTC
      ": : "c"(OTCSTART), "a"(OTCEND), "b"((void*)psxM) : "%eax","%ecx","%ebx" );

      psxML[OTCSTART]=0x00ffffff;
}

PadDataS padd1;
PadDataS padd2;

void updateDisplay()
{
 MSG msg;

 DoPAD=0x80;
 VsyncCount++;
 psxHL[0x1070>>2]|=1;
 if (psxHL[0x1074>>2]&1) hardInterrupt=1;

 GPU_updateLace() ;

 if (PeekMessage(&msg, NULL, 0U, 0U, PM_NOREMOVE))
  {
   GetMessage(&msg, NULL, 0, 0);
   TranslateMessage(&msg);
   DispatchMessage(&msg);
  }

 PAD__readPort1(&padd1);
 pad1d[3] = (unsigned char)(padd1.buttonStatus);
 pad1d[4] = (unsigned char)(padd1.buttonStatus >> 8);
 PAD__readPort2(&padd2);
 pad2d[3] = (unsigned char)(padd2.buttonStatus);
 pad2d[4] = (unsigned char)(padd2.buttonStatus >> 8);

 if (MDECSKIP==2) { MDECSKIP=1; pad1d[3]=pad1d[4]=0; }

 if (VsyncCount&3)
 {
  if (GetAsyncKeyState(VK_ESCAPE))
   {
    SPU__shutdown(); SPU__close(); GPU__close();
    if (MessageBox(opio, "Are you sure you want to quit?", "AdriPSX Emulator", MB_YESNO ) == IDYES) salDOS("\n");
    SPU__init(); GPU__open(opio); SPU__open(opio);
   }

  else if (GetAsyncKeyState(VK_F12))
   {
   if (Runt==0) return;
   CPUTYPE^=1;
    {
     char mes[256];
     sprintf (mes, "CPU TYPE %01x", CPUTYPE);
     MessageBox(opio, mes, "AdriPSX Emulator", MB_OK);
    }
    setmeml(PSXused,TENER,524288);
    if (CPUTYPE) ejecutaOLD();
    else ejecuta();
   }

  else if (GetAsyncKeyState(VK_F4)) { if (Runt) WriteSTS(); }
  else if (GetAsyncKeyState(VK_F5))
    {
     if (Runt)
       {
        SPU__shutdown(); SPU__close(); GPU__close();
        AskSTS();
        SPU__init(); GPU__open(opio); SPU__open(opio);
        ReadSTS();
       }
    }
  else if (GetAsyncKeyState(VK_F11))
   {
    if (Runt==0) return;
    ScanHLE(0, 0x1ffc00);
    setmeml(PSXused,TENER,524288);
    asm("movl $_PSXcode, _NextFree");
   }
 }

}
