static void SPUdmaCPU2SPU(unsigned long madr,unsigned long size)
{
	while(size > 0)
	{
                SPU_writeDMA(psxMW[madr>>1]);
                SPU_writeDMA(psxMW[(madr>>1)+1]);
		size--;
                madr+=4;
	}
}

static void SPUdmaSPU2CPU(unsigned long madr,unsigned long size)
{
	while(size > 0)
	{
                psxMW[madr>>1] =SPU_readDMA();
                psxMW[(madr>>1)+1] =SPU_readDMA();
		size--;
                madr+=4;
	}
}

static void dma4_exec(unsigned long madr, unsigned long bcr, unsigned long chcr)
{
  switch (chcr)
    {
      case 0x01000201:
       {
        if (madr&0x5f800000) { return; }
        SPUdmaCPU2SPU((madr&0x1fffff), ((unsigned short)(bcr>>16) * (unsigned short)(bcr)));
        break;
       }
      case 0x01000200:
       {
        if (madr&0x5f800000) { return; }
        SPUdmaSPU2CPU((madr&0x1fffff), ((unsigned short)(bcr>>16) * (unsigned short)(bcr)));
        break;
       }
    }
}
