typedef struct {
        unsigned char id[8]; unsigned long text; unsigned long data; unsigned long pc0;
        unsigned long gp0; unsigned long t_addr; unsigned long t_size; unsigned long d_addr;
        unsigned long Qd_size; unsigned long Qb_addr; unsigned long Qb_size; unsigned long saddr;
        unsigned long s_size; unsigned long SavedSP; unsigned long SavedFP; unsigned long SavedGP;
        unsigned long SavedRA; unsigned long SavedS0;
} EXE_HEADER;

 typedef struct
 {
  int freq;
  int nbits;
  int stereo;
  int nsamples;
  long y0a, y1a, y0b, y1b;
  short pcm[16384];
 } xa_decode_t;

 typedef struct
 {
  char GPUplugin[128];
  char SPUplugin[128];
  char CDRplugin[128];
  char PADplugin[128];
  char CDRletter;
  char BIOSfile[128];
  char XADEC, SPUDEC, CDDEC;
  char NEWSPU, NEWGPU;
  char MULTITASK;
  char CPUTYPE;
  int kbinds[16];
 } AdriConfig;


typedef struct
{
 unsigned char controllerType;
 unsigned short buttonStatus;
 unsigned char rightJoyX, rightJoyY, leftJoyX, leftJoyY;
 unsigned char moveX, moveY;
 unsigned char negConWheel;
 unsigned char negConB1, negConB2, negConB3;
 unsigned char reserved[87];
} PadDataS;

typedef struct
{
 unsigned char name[20];
 unsigned long attr;
 unsigned long size;
 unsigned long next;
 unsigned char system[8];
} DIRENTRY;

typedef struct {
    UINT8 minute;
    UINT8 second;
    UINT8 frame;
    UINT8 pad;
} CDLoc;

typedef struct
 {
  int rPC;
  int regLO, regHI;
  int NextRTC0,NextRTC1,NextRTC2;
  int TargetRTC0,TargetRTC1,TargetRTC2;
  int InstrCountHoriz,VerticalLine,VsyncCount,hardInterrupt;
  int delayCD,temporizer,rread,cdpos,cdOCUP;
  int cdStat, cdParam[8],cdResult[8],cdParamC,cdParamP,cdResultReady,cdReaded;
  int cdResultTN[6],cdResultTD[4],cdSetSector[4],cdSetSectorSeek[4];
  int cdPlay,cdMode,cdFile,cdChannel,cdTrack,cdMuted,cdReset,cdV,DoPAD;
  int tt[256];
 } savestate_t;

typedef struct
 {
  unsigned long ulFreezeVersion;
  unsigned long ulStatus;
  unsigned long ulControl[256];
  unsigned char psxVRam[1024*512*2];
 } GPUFreeze_t;

