#include <stdio.h>

#define putmeml(DESTINO, DATO, CONTADOR) \
asm("cld \n rep \n stosl %%eax, %%es:(%%edi) \n" : : "D"((void*)DESTINO), "a"(DATO), "c"(CONTADOR) : "%edi", "%eax", "%ecx")

extern unsigned char psxM[2*1024*1034] asm("psxM");
extern unsigned long MDECSKIP;
extern unsigned long pad1m;
extern unsigned char pad1d[5];

void CleanRec(unsigned long adres, unsigned long size);

#define	RAMADDR(addr) ((void*)&psxM[(addr)&0x1fffff])

#define FIX_1_082392200  (277)
#define FIX_1_414213562  (362)
#define FIX_1_847759065  (473)
#define FIX_2_613125930  (669)

#define MP(var,const)  (DC((var) * (const), 8))
#define DC(x,n)  ((x)>>(n))

static unsigned long roundtbl[256*3];

static void idct(int *block,int k)
{
  int tmp0, tmp1, tmp2, tmp3, tmp4, tmp5, tmp6, tmp7;
  int z5, z10, z11, z12, z13;
  int *ptr;
  int i;

  if (k == 1)
   {
     putmeml(block, ((int)(DC(block[0], 5))), 64);
     return;
   }

  ptr = block;
  for (i = 0; i< 8; i++,ptr++) {
    
    if (

     ({
      register int t;
      asm("
      xorl %%ecx, %%ecx
      orl 32(%%eax), %%ecx
      orl 64(%%eax), %%ecx
      orl 96(%%eax), %%ecx
      orl 128(%%eax), %%ecx
      orl 160(%%eax), %%ecx
      orl 192(%%eax), %%ecx
      orl 224(%%eax), %%ecx
      " : "=c"(t): "a"((void*)ptr) : "%eax", "%ecx");
      t;
     })==0
    )
    {
      ptr[8] = ptr[16] = ptr[24] = ptr[32] = ptr[40] = ptr[48] = ptr[56] = ptr[0];
      continue;
    }
    
    z10 = ptr[0] + ptr[32]; z11 = ptr[0] - ptr[32];
    z13 = ptr[16] + ptr[48]; z12 = MP(ptr[16] - ptr[48], FIX_1_414213562) - z13;
    tmp0 = z10 + z13; tmp3 = z10 - z13;
    tmp1 = z11 + z12; tmp2 = z11 - z12;

    z13 = ptr[24] + ptr[40]; z10 = ptr[24] - ptr[40];
    z11 = ptr[8] + ptr[56]; z12 = ptr[8] - ptr[56];

    z5 = MP(z12 - z10, FIX_1_847759065);
    tmp7 = z11 + z13;
    tmp6 = MP(z10, FIX_2_613125930) + z5 - tmp7;
    tmp5 = MP(z11 - z13, FIX_1_414213562) - tmp6;
    tmp4 = MP(z12, FIX_1_082392200) - z5 + tmp5;

    ptr[0] = (tmp0 + tmp7); ptr[56] = (tmp0 - tmp7);
    ptr[8] = (tmp1 + tmp6); ptr[48] = (tmp1 - tmp6);
    ptr[16] = (tmp2 + tmp5); ptr[40] = (tmp2 - tmp5);
    ptr[32] = (tmp3 + tmp4); ptr[24] = (tmp3 - tmp4);
  }
  
  ptr = block;
  for (i = 0; i < 8; i++ ,ptr+=8) {
    
    if (
     ({
      register int t;
      asm("
      xorl %%ecx, %%ecx
      orl 4(%%eax), %%ecx
      orl 8(%%eax), %%ecx
      orl 12(%%eax), %%ecx
      orl 16(%%eax), %%ecx
      orl 20(%%eax), %%ecx
      orl 24(%%eax), %%ecx
      orl 28(%%eax), %%ecx
      " : "=c"(t): "a"((void*)ptr) : "%eax", "%ecx");
      t;
     })==0
    )
     {
      ptr[0] = ptr[1] = ptr[2] = ptr[3] = ptr[4] = ptr[5] = ptr[6] = ptr[7] = DC(ptr[0], 2+3);
      continue;
     }

    z10 = ptr[0] + ptr[4]; z11 = ptr[0] - ptr[4];
    z13 = ptr[2] + ptr[6]; z12 = MP(ptr[2] - ptr[6], FIX_1_414213562) - z13;

    tmp0 = z10 + z13; tmp3 = z10 - z13;
    tmp1 = z11 + z12; tmp2 = z11 - z12;

    z13 = ptr[3] + ptr[5]; z10 = ptr[3] - ptr[5];
    z11 = ptr[1] + ptr[7]; z12 = ptr[1] - ptr[7];

    z5 = MP(z12 - z10, FIX_1_847759065);
    tmp7 = z11 + z13;
    tmp6 = MP(z10, FIX_2_613125930) + z5 - tmp7;
    tmp5 = MP(z11 - z13, FIX_1_414213562) - tmp6;
    tmp4 = MP(z12, FIX_1_082392200) - z5 + tmp5;

    ptr[0] = DC(tmp0 + tmp7, 5);
    ptr[7] = DC(tmp0 - tmp7, 5);
    ptr[1] = DC(tmp1 + tmp6, 5);
    ptr[6] = DC(tmp1 - tmp6, 5);
    ptr[2] = DC(tmp2 + tmp5, 5);
    ptr[5] = DC(tmp2 - tmp5, 5);
    ptr[4] = DC(tmp3 + tmp4, 5);
    ptr[3] = DC(tmp3 - tmp4, 5);

  }
}

static unsigned short* rl2blk(int *blk,unsigned short *mdec_rl);
static void iqtab_init(signed int *iqtab,unsigned char *iq_y);
static void yuv2rgb24(int *blk,unsigned char *image);
static void yuv2rgb15(int *blk,unsigned short *image);

struct
 {
  unsigned long command;
  unsigned long status;
  unsigned short *rl;
  int rlsize;
 } mdec;

unsigned int iq_y[64],iq_uv[64];

void mdec_init(void)
{
 register int i;
 for(i=0;i<256;i++)
  {
   roundtbl[i]=0; roundtbl[i+256]=i; roundtbl[i+512]=255;
  }
 mdec.command = 0;
 mdec.status = 0;
}

void mdec0_write(unsigned long data)
{
	mdec.command = data;
	if ((data&0xf5ff0000)==0x30000000) mdec.rlsize = data&0xffff;
}

unsigned long mdec1_read(void)
{
	return mdec.status;
}

void do_DMA0(unsigned long adr, unsigned long bcr, unsigned long chcr)
{
	int cmd = mdec.command, size;

	if (chcr!=0x01000201) return;
	size = (bcr>>16)*(bcr&0xffff);
        if (adr&0x5f800000) { return; }
        if (((adr&0x001fffff)+size)>0x1fffff) { return; }

	if (cmd==0x40000001)
	 {
	  unsigned char *p = RAMADDR(adr);
	  iqtab_init(iq_y,p);
          iqtab_init(iq_uv,p+64);
	 }
	else if ((cmd&0xf5ff0000)==0x30000000) mdec.rl = RAMADDR(adr);
}

void do_DMA1(unsigned long adr, unsigned long bcr, unsigned long chcr)
{
	int size = (bcr>>16)*(bcr&0xffff);
	int blk[64*6], blocksize;
	unsigned short	*image = RAMADDR(adr);

	if (chcr!=0x01000200) return;
        if (MDECSKIP) { return; }
        if (adr&0x5f800000) { return; }
        if (((adr&0x001fffff)+size)>0x1fffff) { return; }

	if (mdec.command&0x08000000) blocksize = 16*16;
	else blocksize = 24*16;

	for(;size>0;size-=blocksize/2,image+=blocksize)
 	 {
          mdec.rl = rl2blk(blk,mdec.rl);
          if (mdec.command&0x08000000) yuv2rgb15(blk,image);
          else yuv2rgb24(blk,(unsigned char *)image);
	 }
}

#define	RUNOF(a)	((a)>>10)
#define	VALOF(a)	(((int)(a)<<(32-10))>>(32-10))

int zscan[64] = {
	0 ,1 ,8 ,16,9 ,2 ,3 ,10,17,24,32,25,18,11,4 ,5 ,
	12,19,26,33,40,48,41,34,27,20,13,6 ,7 ,14,21,28,
	35,42,49,56,57,50,43,36,29,22,15,23,30,37,44,51,
	58,59,52,45,38,31,39,46,53,60,61,54,47,55,62,63
};

int aanscales[64] = {
	  16384, 22725, 21407, 19266, 16384, 12873,  8867,  4520,
	  22725, 31521, 29692, 26722, 22725, 17855, 12299,  6270,
	  21407, 29692, 27969, 25172, 21407, 16819, 11585,  5906,
	  19266, 26722, 25172, 22654, 19266, 15137, 10426,  5315,
	  16384, 22725, 21407, 19266, 16384, 12873,  8867,  4520,
	  12873, 17855, 16819, 15137, 12873, 10114,  6967,  3552,
	   8867, 12299, 11585, 10426,  8867,  6967,  4799,  2446,
	   4520,  6270,  5906,  5315,  4520,  3552,  2446,  1247
};

static void iqtab_init(signed int *iqtab,unsigned char *iq_y)
{
	register int i;
	for(i=0;i<64;i++)
	   iqtab[i] = ((unsigned long)(iq_y[i])*aanscales[zscan[i]])>>12;
}

static unsigned short* rl2blk(int *blk,unsigned short *mdec_rl)
{
	int i, k, q_scale, rl, *iqtab;

	putmeml(blk,0,384);
	for(i=0;i<6;i++)
	 {
	  if (i<2) iqtab = iq_uv;
	  else iqtab = iq_y;
	  rl = *mdec_rl++;
	  q_scale = RUNOF(rl);
	  blk[0] = iqtab[0]*VALOF(rl);
	  k = 0;
	  for(;;)
	   {
            rl = *mdec_rl++; if (rl==0xfe00) break;
            k += RUNOF(rl)+1; if (k>63) break;
            blk[zscan[k]] = (iqtab[k]*VALOF(rl)*q_scale) >> 3;
	   }
          idct(blk,k+1);
	  blk+=64;
	 }
	return mdec_rl;
}

#define toFIX(a)        (int)((a)*4096)
#define	toINT(a)	((a)>>12)
#define	MULR(a)	        toINT((a)*toFIX(1.402))
#define	MULG(a)	        toINT((a)*toFIX(-0.3437))
#define	MULG2(a)	toINT((a)*toFIX(-0.7143))
#define	MULB(a)	        toINT((a)*toFIX(1.772))

#define	RGB15(r,g,b)	( (((r)>>3)<<10)|(((g)>>3)<<5)|((b)>>3) )
#define	ROUND(c)        ((unsigned long*)roundtbl+384)[c]

static void yuv2rgb15(int *blk,unsigned short *image)
{
	int x,yy;
	int *yblk = blk+128;
	for(yy=0;yy<16;yy+=2,blk+=4,yblk+=8,image+=24)
	 {
	  if (yy==8) yblk+=64;
	  for(x=0;x<4;x++,blk++,yblk+=2,image+=2)
	   {
            int r0,b0,g0,y;
            r0 = MULR(blk[64]); g0 = MULG(blk[0])+MULG2(blk[64]); b0 = MULB(blk[0]);
            if ((r0<-768)||(r0>768)) r0=r0%768;
            if ((g0<-768)||(g0>768)) g0=g0%768;
            if ((b0<-768)||(b0>768)) b0=b0%768;
            y = yblk[0]; image[0] = RGB15(ROUND(r0+y),ROUND(g0+y),ROUND(b0+y));
            y = yblk[1]; image[1] = RGB15(ROUND(r0+y),ROUND(g0+y),ROUND(b0+y));
            y = yblk[8]; image[16] = RGB15(ROUND(r0+y),ROUND(g0+y),ROUND(b0+y));
            y = yblk[9]; image[17] = RGB15(ROUND(r0+y),ROUND(g0+y),ROUND(b0+y));
            r0 = MULR(blk[68]); g0 = MULG(blk[4])+MULG2(blk[68]); b0 = MULB(blk[4]);
            if ((r0<-768)||(r0>768)) r0=r0%768;
            if ((g0<-768)||(g0>768)) g0=g0%768;
            if ((b0<-768)||(b0>768)) b0=b0%768;
            y = yblk[64]; image[8] = RGB15(ROUND(r0+y),ROUND(g0+y),ROUND(b0+y));
            y = yblk[65]; image[9] = RGB15(ROUND(r0+y),ROUND(g0+y),ROUND(b0+y));
            y = yblk[72]; image[24] = RGB15(ROUND(r0+y),ROUND(g0+y),ROUND(b0+y));
            y = yblk[73]; image[25] = RGB15(ROUND(r0+y),ROUND(g0+y),ROUND(b0+y));
	   }
	}
}

static void yuv2rgb24(int *blk,unsigned char *image)
{
	int x, yy;
	int *yblk = blk+128;

	for(yy=0;yy<16;yy+=2,blk+=4,yblk+=8,image+=72)
	 {
	  if (yy==8) yblk+=64;
	  for(x=0;x<4;x++,blk++,yblk+=2,image+=6)
	   {
	    int r0,b0,g0, *y;
            r0 = MULR(blk[64]); g0 = MULG(blk[0])+MULG2(blk[64]); b0 = MULB(blk[0]);
            if ((r0<-768)||(r0>768)) r0=r0%768;
            if ((g0<-768)||(g0>768)) g0=g0%768;
            if ((b0<-768)||(b0>768)) b0=b0%768;
            y = (void*)roundtbl+(yblk[0]*4)+384*4;
            image[0] = y[b0]; image[1] = y[g0]; image[2] = y[r0];
            y = (void*)roundtbl+(yblk[1]*4)+384*4;
            image[3] = y[b0]; image[4] = y[g0]; image[5] = y[r0];
            y = (void*)roundtbl+(yblk[8]*4)+384*4;
            image[48] = y[b0]; image[49] = y[g0]; image[50] = y[r0];
            y = (void*)roundtbl+(yblk[9]*4)+384*4;
            image[51] = y[b0]; image[52] = y[g0]; image[53] = y[r0];
            r0 = MULR(blk[68]); g0 = MULG(blk[4])+MULG2(blk[68]); b0 = MULB(blk[4]);
            if ((r0<-768)||(r0>768)) r0=r0%768;
            if ((g0<-768)||(g0>768)) g0=g0%768;
            if ((b0<-768)||(b0>768)) b0=b0%768;
            y = (void*)roundtbl+(yblk[64]*4)+384*4;
            image[24] = y[b0]; image[25] = y[g0]; image[26] = y[r0];
            y = (void*)roundtbl+(yblk[65]*4)+384*4;
            image[27] = y[b0]; image[28] = y[g0]; image[29] = y[r0];
            y = (void*)roundtbl+(yblk[72]*4)+384*4;
            image[72] = y[b0]; image[73] = y[g0]; image[74] = y[r0];
            y = (void*)roundtbl+(yblk[73]*4)+384*4;
            image[75] = y[b0]; image[76] = y[g0]; image[77] = y[r0];
           }
	}
}
